> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Project Environment Classes

> Updates all environment classes of a project.

`Unary` · [`Projects`](https://ona.com/docs/api-reference/generated/project/overview)

Updates all environment classes of a project.

Use this method to:

* Modify all environment classea of a project

### Examples

* Update project environment classes:

  Updates all environment classes for a project.

  ```yaml theme={null}
  projectId: "b0e12f6c-4c67-429d-a4a6-d9838b5da047"
  projectEnvironmentClasses:
    - environmentClassId: "b0e12f6c-4c67-429d-a4a6-d9838b5da041"
      order: 0
    - localRunner: true
      order: 1
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.ProjectService/UpdateProjectEnvironmentClasses
```

Send a Bearer token as described in [Authentication](https://ona.com/docs/api-reference.md#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

```bash cURL theme={null}
export ONA_HOST=https://app.ona.com
export ONA_API_KEY=<your-token>

curl --request POST \
  --url "$ONA_HOST/api/gitpod.v1.ProjectService/UpdateProjectEnvironmentClasses" \
  --header "Authorization: Bearer $ONA_API_KEY" \
  --header "Content-Type: application/json" \
  --data '{
  "projectId": "<project-id>"
}'
```

```python Python theme={null}
import gitpod.v1.project_pb2 as project_pb2
from ona_sdk import create_client_from_env

ona = create_client_from_env()
request = project_pb2.UpdateProjectEnvironmentClassesRequest(
    project_id="<project-id>",
)
response = ona.services.project.update_project_environment_classes(request)
print(response)
```

```typescript TypeScript theme={null}
import { create } from "@bufbuild/protobuf";
import { createClientFromEnv } from "@gitpod/sdk";
import { UpdateProjectEnvironmentClassesRequestSchema } from "@gitpod/sdk/gitpod/v1/project_pb";

async function main() {
  const ona = createClientFromEnv();
  const request = create(UpdateProjectEnvironmentClassesRequestSchema, {
    projectId: "<project-id>",
  });
  const response = await ona.services.project.updateProjectEnvironmentClasses(request);
  console.log(response);
}

main().catch(console.error);
```

```go Go theme={null}
package main

import (
	"context"
	"fmt"
	"log"

	"connectrpc.com/connect"
	"github.com/gitpod-io/gitpod-sdk-go/sdk"
	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
)

func main() {
	ona, err := sdk.NewFromEnv()
	if err != nil {
		log.Fatal(err)
	}

	request := connect.NewRequest(&gitpodpb.UpdateProjectEnvironmentClassesRequest{
		ProjectId: "<project-id>",
	})
	response, err := ona.Services.Project.UpdateProjectEnvironmentClasses(context.Background(), request)
	if err != nil {
		log.Fatal(err)
	}
	fmt.Println(response.Msg)
}
```

```json Request body theme={null}
{
  "projectId": "<project-id>"
}
```

## Request

`gitpod.v1.UpdateProjectEnvironmentClassesRequest`

UpdateProjectEnvironmentClassesRequest updates all project environment classes of a project.

| Field | Type | Required | Description |
| - | - | - | - |
| `projectId` | string | No | project\_id specifies the project identifier Constraints: `string.uuid=true`. |
| `projectEnvironmentClasses` | array of [ProjectEnvironmentClass](#type-gitpod-v1-project-environment-class) | No | Constraints: `repeated.max_items=30, repeated.min_items=1`. |

## Response

`gitpod.v1.UpdateProjectEnvironmentClassesResponse`

This message has no fields.

## Related types

> [accordion] ProjectEnvironmentClass
>
> `gitpod.v1.ProjectEnvironmentClass`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `localRunner` | boolean | No | Use a local runner for the user |
> | `environmentClassId` | string | No | Use a fixed environment class on a given Runner. This cannot be a local runner's environment class. Constraints: `string.uuid=true`. |
> | `order` | integer | No | order is the priority of this entry |


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.